<?php

/**
 * Fix post thumbnail missing in single pages for PTB posts
 *
 * @return Yoast\WP\SEO\Values\Open_Graph\Images
 */
function themify_ptb_wpseo_add_opengraph_images( $image ) {
	$ptb = PTB_Public::get_instance();
	if ( $ptb::$is_single ) {
		if ( $featured_image = get_post_thumbnail_id( $ptb->get_actual_query()->queried_object_id ) ) {
			$image->add_image_by_id( $featured_image );
		}
	}

	return $image;
}
add_filter( 'wpseo_add_opengraph_images', 'themify_ptb_wpseo_add_opengraph_images' );

function themify_ptb_wpseo_add_opengraph_desc( $desc ) {
	$ptb = PTB_Public::get_instance();
	if ( $ptb::$is_single && empty( $desc ) ) {
		$desc = get_post_meta( $ptb->get_actual_query()->queried_object_id, '_yoast_wpseo_metadesc', true );
	}

	return $desc;
}
add_filter( 'wpseo_opengraph_desc', 'themify_ptb_wpseo_add_opengraph_desc' );

function themify_ptb_wpseo_add_opengraph_title( $title ) {
    $ptb = PTB_Public::get_instance();
	if ( $ptb::$is_single && empty( $title ) ) {
		$title = get_post_meta( $ptb->get_actual_query()->queried_object_id, '_yoast_wpseo_title', true );
        /* Replace `%%variable_placeholders%%` with their real value */
        $replacer = \Yoast\WP\SEO\WordPress\Wrapper::get_replace_vars();
        $title = $replacer->replace( $title, get_post( $ptb->get_actual_query()->queried_object_id ) );
	}

	return $title;
}
add_filter( 'wpseo_opengraph_title', 'themify_ptb_wpseo_add_opengraph_title' );
add_filter( 'wpseo_title', 'themify_ptb_wpseo_add_opengraph_title' );